## tango 10.1.0+dfsg1

=== CMakeLists.txt ===
# vim: noautoindent:
cmake_minimum_required(VERSION 3.18...3.26 FATAL_ERROR)

project(TangoSourceDistribution LANGUAGES CXX)

set(SHELL "/usr/bin/env sh")

get_property(IS_MULTI_CONFIG GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)

if(NOT IS_MULTI_CONFIG AND NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release")
endif()

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# switches
option(TSD_LIB "Install and use bundled libtango, if OFF use libtango found on system" ON)
option(TSD_CPP "Installation of cppTango and C++ applications" ON)
option(TSD_JAVA "Installation of java applications" ON)
option(TSD_DATABASE "Installation of tango database server" ON)
option(TSD_TAC "Installation of access control server" OFF)
option(TSD_HTML_DOCUMENTATION "Include the HTML documentation" ON)

# non-boolean knobs
SET(TSD_JAVA_PATH "" CACHE STRING "Path to the java interpreter")

if(TSD_JAVA)
  set(JAVA_HOME ${TSD_JAVA_PATH})

  find_package(Java 17 COMPONENTS Runtime REQUIRED)

  set(TSD_JAVA_VERSION ${Java_VERSION_STRING})
  set(TSD_JAVA_EXEC ${Java_JAVA_EXECUTABLE})
else()
  set(TSD_JAVA_VERSION "unknown")
  set(TSD_JAVA_EXEC "unknown")
endif()

SET(TSD_RC_FILE "/etc/tangorc")

if(TSD_CPP)
  # Overwrite settings of included projects
  option(BUILD_TESTING "Enable building the cppTango tests" OFF)

  if(TSD_LIB)
    set(tangoidl_FOUND ON CACHE BOOL "")
    set(IDL_VERSION_FOUND "6.0.4" CACHE STRING "")

    add_library(tangoidl::tangoidl INTERFACE IMPORTED)
    set_target_properties(tangoidl::tangoidl PROPERTIES
      INTERFACE_INCLUDE_DIRECTORIES "${CMAKE_CURRENT_SOURCE_DIR}/lib/idl/include")

    list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
  endif()
else()
  if(TSD_DATABASE)
    message(STATUS "Forcing TSD_DATABASE to OFF as TSD_CPP is disabled")
    set(TSD_DATABASE OFF)
  endif()

  if(TSD_TAC)
    message(STATUS "Forcing TSD_TAC to OFF as TSD_CPP is disabled")
    set(TSD_TAC OFF)
  endif()
endif()

add_subdirectory(lib)

add_subdirectory(cppserver)
add_subdirectory(doc)
add_subdirectory(pogo)

if(TSD_DATABASE)
  add_subdirectory(scripts)
endif()

add_subdirectory(utils)

# mysql/mariadb server is found in TangoDatabase cmake logic

set(TSD_OMNIORB_VERSION ${OMNIORB_VERSION})
set(TSD_OMNIORB_PATH ${omniORB4_INCLUDE_DIR})

set(TSD_ZMQ_PATH ${ZeroMQ_INCLUDE_DIR})
if(_ZeroMQ_PKG_VERSION)
  set(TSD_ZMQ_VERSION ${_ZeroMQ_PKG_VERSION})
else()
  set(TSD_ZMQ_VERSION "not-yet-supported")
endif()

set(TSD_CPPZMQ_PATH ${cppzmq_INCLUDE_DIR})
if(_cppzmq_PKG_VERSION)
  set(TSD_CPPZMQ_VERSION ${_cppzmq_PKG_VERSION})
else()
  set(TSD_CPPZMQ_VERSION "not-yet-supported")
endif()

# Unfortunately, TangoDatabase's FindMySQL.cmake does not cache MySQL_LIBRARY,
# only MySQL_LIBRARY_RELEASE and MySQL_LIBRARY_DEBUG.
if (NOT MySQL_LIBRARY)
  include(SelectLibraryConfigurations)
  select_library_configurations(MySQL)
endif()

set(TSD_MYSQL_CLIENT_LDLIBS ${MySQL_LIBRARY})
set(TSD_MYSQL_CLIENT_VERSION ${MySQL_VERSION})
set(TSD_MYSQL_SERVER_VERSION ${TDB_DB_VERSION})
set(TSD_MYSQL_SERVER_CONNECTION ${TDB_DB_CONNECTION_RESULT})

message(STATUS                                                                                                               "\
Summary:                                                                                                                   \n \
Configuration (TangoSourceDistribution):                                                                                   \n \
                                                                                                                           \n \
Source code location: ${CMAKE_SOURCE_DIR}                                                                                  \n \
Version: 10.1.0                                                                                                     \n \
Compiler: C++ ${CMAKE_CXX_COMPILER_ID} ${CMAKE_CXX_COMPILER_VERSION}                                                       \n \
                                                                                                                           \n \
OMNIORB PATH: ${TSD_OMNIORB_PATH}                                                                                          \n \
OMNIORB VERSION: ${TSD_OMNIORB_VERSION}                                                                                    \n \
                                                                                                                           \n \
CPPZMQ PATH: ${TSD_CPPZMQ_PATH}                                                                                            \n \
CPPZMQ VERSION: ${TSD_CPPZMQ_VERSION}                                                                                      \n \
                                                                                                                           \n \
ZMQ PATH: ${TSD_ZMQ_PATH}                                                                                                  \n \
ZMQ VERSION: ${TSD_ZMQ_VERSION}                                                                                            \n \
                                                                                                                           \n \
JAVA PATH: ${TSD_JAVA_EXEC}                                                                                                \n \
JAVA VERSION: ${TSD_JAVA_VERSION}                                                                                          \n \
                                                                                                                           \n \
Database:                                                                                                                  \n \
                                                                                                                           \n \
DB NAME: ${TANGO_DB_NAME}                                                                                                  \n \
CLIENT LIB: ${TSD_MYSQL_CLIENT_LDLIBS}                                                                                     \n \
CLIENT VERSION: ${TSD_MYSQL_CLIENT_VERSION}                                                                                \n \
SERVER VERSION: ${TSD_MYSQL_SERVER_VERSION}                                                                                \n \
CONNECTION: ${TSD_MYSQL_SERVER_CONNECTION}                                                                                 \n \
                                                                                                                           \n \
Build:                                                                                                                     \n \
                                                                                                                           \n \
Use packaged cppTango:            ${TSD_LIB}                                                                               \n \
C++ applications and libraries :  ${TSD_CPP}                                                                               \n \
Java application :                ${TSD_JAVA}                                                                              \n \
Access control server:            ${TSD_TAC}                                                                               \n \
Database server:                  ${TSD_DATABASE}                                                                          \n \
HTML documentation:               ${TSD_HTML_DOCUMENTATION}                                                                \n \
Database schema create:           ${TDB_DATABASE_SCHEMA}                                                                   \n \
                                                                                                                           \n \
Please check whether the configuration I detected matches what you would like to have.")

=== cppserver/CMakeLists.txt ===
if(NOT TSD_CPP)
  return()
endif()

# TODO: Remove me when servers use the cmake config file.
# Currently, they use the logic in FindTango.cmake to local libtango, this will
# require updating TangoCMakeModules.
if (WIN32)
  set(CMAKE_CXX_STANDARD 17)
endif()

message(STATUS "Database")
if(TSD_DATABASE)
  add_subdirectory(database)
  list(APPEND BATCH_SCRIPTS start-db.bat)
endif()

message(STATUS "Starter")
add_subdirectory(starter)
list(APPEND BATCH_SCRIPTS start-starter.bat)

message(STATUS "Access Control")
if(TSD_TAC)
  add_subdirectory(tangoaccesscontrol)
endif()

message(STATUS "Test")
add_subdirectory(tangotest)
list(APPEND BATCH_SCRIPTS start-tangotest.bat)

message(STATUS "UniversalTest")
add_subdirectory(universaltest)
list(APPEND BATCH_SCRIPTS start-universaltest.bat)

if (WIN32)
    foreach(input ${BATCH_SCRIPTS})
        install(PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/${input}
                DESTINATION ${CMAKE_INSTALL_BINDIR})
    endforeach()
endif()

=== lib/CMakeLists.txt ===
if (TSD_CPP AND TSD_LIB)
    message(STATUS "C++")
    add_subdirectory(cpp)

    message(STATUS "IDL")
    add_subdirectory(idl)
endif()

if(TSD_JAVA)
  message(STATUS "Java")
  add_subdirectory(java)
endif()

=== pogo/CMakeLists.txt ===
add_subdirectory(preferences)

=== scripts/CMakeLists.txt ===
project(various_scripts)

if (WIN32)
    install(PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/common.bat
            DESTINATION ${CMAKE_INSTALL_BINDIR})
else()
    set(SCRIPTS tango
                tango_wca)

    foreach(input ${SCRIPTS})
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${input}.in ${input} @ONLY)
    install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/${input}
            DESTINATION ${CMAKE_INSTALL_BINDIR})
    endforeach()
endif()

=== utils/CMakeLists.txt ===
if (NOT WIN32)
  if(TSD_CPP)
    add_subdirectory(tango_admin)
  endif()
endif()

=== cppserver/tangoaccesscontrol/CMakeLists.txt ===
add_subdirectory(TangoAccessControl)

=== cppserver/tangotest/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18...3.26 FATAL_ERROR)

project(TangoTest LANGUAGES CXX
        VERSION 3.0)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/TangoCMakeModules)
find_package(Tango REQUIRED)

if(NOT DEFINED CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 17)
endif()

set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_STANDARD_REQUIRED YES)

set(SOURCES
        ClassFactory.cpp
        TangoTest.cpp
        TangoTestClass.cpp
        TangoTestStateMachine.cpp
        main.cpp)

set(HEADERS
        TangoTest.h
        TangoTestClass.h)

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

add_library(TangoTestObjects OBJECT ${SOURCES} ${HEADERS})
target_link_libraries(TangoTestObjects PRIVATE Tango::Tango)

add_executable(${PROJECT_NAME} $<TARGET_OBJECTS:TangoTestObjects>)
target_link_libraries(${PROJECT_NAME} PRIVATE Tango::Tango)

add_library("${PROJECT_NAME}Shared" SHARED $<TARGET_OBJECTS:TangoTestObjects>)
target_link_libraries("${PROJECT_NAME}Shared" PRIVATE Tango::Tango)
set_target_properties("${PROJECT_NAME}Shared" PROPERTIES OUTPUT_NAME ${PROJECT_NAME})

install(TARGETS ${PROJECT_NAME} "${PROJECT_NAME}Shared" RUNTIME DESTINATION bin)

if (WIN32 AND (Tango_IS_STATIC OR Tango_FORCE_STATIC))
    set_target_properties(${PROJECT_NAME} "${PROJECT_NAME}Shared" TangoTestObjects
      PROPERTIES MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>"
    )
endif()

option(TANGO_WARNINGS_AS_ERRORS "Treat compiler warnings as errors" OFF)

if(TANGO_WARNINGS_AS_ERRORS)
  target_compile_options(${PROJECT_NAME} PUBLIC -Werror -Wall -Wextra -Wformat -Werror=format-security -pedantic)
endif()

=== doc/src/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    = -n -W -w sphinx-output.log
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
$(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don't have Sphinx installed, grab it from http://sphinx-doc.org/)
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	rm -rf $(BUILDDIR)/*

html:
	@echo Generating glossary
	@python glossary_generator.py
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

livehtml:
	@echo Generating glossary
	@python glossary_generator.py
	sphinx-autobuild --ignore source/_tags source "$(BUILDDIR)" $(SPHINXOPTS) $(O)

glossary:
	@echo Generating glossary
	@python glossary_generator.py

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/TangoControlsDocumentation.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/TangoControlsDocumentation.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/TangoControlsDocumentation"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/TangoControlsDocumentation"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

=== lib/cpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18...4.0 FATAL_ERROR)
# minimum version: https://gitlab.com/tango-controls/docker/ci/cpptango/debian-minimum-versions
# maximum version: https://gitlab.com/tango-controls/docker/ci/cpptango/debian-maximum-cmake

project(cppTango LANGUAGES CXX
                 HOMEPAGE_URL "https://www.tango-controls.org"
                 DESCRIPTION "Distributed Control System")

if (NOT DEFINED CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 17)
endif()
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

include(CTest)

set(CMAKE_TRY_COMPILE_CONFIGURATION "${CMAKE_BUILD_TYPE}")

option(TANGO_WARNINGS_AS_ERRORS "Treat compiler warnings as errors" OFF)
option(BUILD_SHARED_LIBS "Build a shared library instead of static" ON)
option(TANGO_USE_LIBCPP "Build against libc++" OFF)

option(TANGO_ENABLE_COVERAGE "Instrument code for coverage analysis" OFF)
if (TANGO_ENABLE_COVERAGE AND NOT (CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang"))
    message(WARNING "Code coverage is not supported for selected compiler.")
    set(TANGO_ENABLE_COVERAGE OFF)
endif()

set(TANGO_ENABLE_SANITIZER "" CACHE STRING "Enable sanitizer")
set(TANGO_SUPPORTED_SANITIZERS ASAN TSAN UBSAN MSAN)
set_property(CACHE TANGO_ENABLE_SANITIZER PROPERTY STRINGS ${TANGO_SUPPORTED_SANITIZERS})

if(TANGO_ENABLE_SANITIZER AND NOT (CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang"))
    message(FATAL_ERROR "Sanitizers are not supported for selected compiler.")
endif()
if(TANGO_ENABLE_SANITIZER AND NOT (TANGO_ENABLE_SANITIZER IN_LIST TANGO_SUPPORTED_SANITIZERS))
    message(FATAL_ERROR "TANGO_ENABLE_SANITIZER must be one of: ${TANGO_SUPPORTED_SANITIZERS}.")
endif()
if(TANGO_ENABLE_SANITIZER STREQUAL "MSAN" AND CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    message(FATAL_ERROR "MSAN is not supported for selected compiler.")
endif()
if(TANGO_ENABLE_SANITIZER)
    find_program(ADDR2LINE_PROGRAM "addr2line")
    find_program(LLVM_SYMBOLIZER_PROGRAM "llvm-symbolizer")
    if(NOT ADDR2LINE_PROGRAM)
        message(FATAL_ERROR "Could not find addr2line (required for sanitizers).")
    endif()
    if(NOT LLVM_SYMBOLIZER_PROGRAM AND CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
        message(FATAL_ERROR "Could not find llvm-symbolizer (required for sanitizers).")
    endif()
endif()


# telemetry
option(TANGO_USE_TELEMETRY "Enable telemetry (OpenTelemetry)" ON)
include(CMakeDependentOption)
CMAKE_DEPENDENT_OPTION(TANGO_TELEMETRY_USE_HTTP "Enable http protocol for telemetry (OpenTelemetry)" ON "TANGO_USE_TELEMETRY" OFF)
CMAKE_DEPENDENT_OPTION(TANGO_TELEMETRY_USE_GRPC "Enable gRPC protocol for telemetry (OpenTelemetry)" ON "TANGO_USE_TELEMETRY" OFF)

#need to define the version of the library
set(MAJOR_VERSION "10")
set(MINOR_VERSION "1")
set(PATCH_VERSION "0")

if(WIN32)
    include(configure/cmake_win_defs.cmake)
endif()

include(configure/git.cmake)
git_describe(GIT_DESCRIPTION SUFFIX_VERSION)

#convenient versions
set(LIBRARY_VERSION "${MAJOR_VERSION}.${MINOR_VERSION}.${PATCH_VERSION}${SUFFIX_VERSION}")
set(SO_VERSION "${MAJOR_VERSION}.${MINOR_VERSION}")

set(TANGO_GIT_REVISION "${GIT_DESCRIPTION}")

include(configure/CMakeLists.txt)

set(TANGO_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(TANGO_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR})

#source code
add_subdirectory("log4tango")
add_subdirectory("src")

if(BUILD_TESTING)
  add_subdirectory("tests")
endif()

add_library(tango $<TARGET_OBJECTS:log4tango_objects>
                  $<TARGET_OBJECTS:common_objects>
                  $<TARGET_OBJECTS:client_objects>
                  $<TARGET_OBJECTS:idl_objects>
                  $<TARGET_OBJECTS:server_objects>)

set_cflags_and_include(tango)

target_include_directories(tango INTERFACE
    $<BUILD_INTERFACE:${TANGO_SOURCE_DIR}/src/include>
    $<BUILD_INTERFACE:${TANGO_SOURCE_DIR}/log4tango/include>
    $<BUILD_INTERFACE:${TANGO_BINARY_DIR}/src/include>
    $<BUILD_INTERFACE:${TANGO_BINARY_DIR}/log4tango/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)

target_compile_features(tango INTERFACE cxx_std_17)

target_compile_definitions(tango INTERFACE "$<$<AND:$<BOOL:${BUILD_SHARED_LIBS}>,$<CXX_COMPILER_ID:MSVC>>:TANGO_HAS_DLL>")

add_library(Tango::Tango ALIAS tango)

if(WIN32)
    include(configure/cmake_win.cmake)
    include(configure/cpack_win.cmake)
else()
    include(configure/cmake_linux.cmake)
endif()

include(configure/install.cmake)

include(CPack)

=== lib/idl/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18...3.26 FATAL_ERROR)

project(tangoidl)

#need to define the version of the library
set(MAJOR_VERSION "6")
set(MINOR_VERSION "0")
set(PATCH_VERSION "4")

#convenient versions
set(LIBRARY_VERSION "${MAJOR_VERSION}.${MINOR_VERSION}.${PATCH_VERSION}")

project(tangoidl VERSION ${LIBRARY_VERSION})

include(GNUInstallDirs)

add_library(tangoidl INTERFACE)

target_include_directories(tangoidl
    INTERFACE
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>)

include(CMakePackageConfigHelpers)

write_basic_package_version_file(
    "${PROJECT_BINARY_DIR}/tangoidlConfigVersion.cmake"
    VERSION ${LIBRARY_VERSION}
    COMPATIBILITY AnyNewerVersion
    ARCH_INDEPENDENT)

set(ConfigPackageLocation ${CMAKE_INSTALL_LIBDIR}/cmake/tangoidl)
set(Namespace tangoidl::)

install(TARGETS tangoidl
    EXPORT tangoidlTargets
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT Runtime
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT Development
    RUNTIME DESTINATION bin COMPONENT Runtime
    PUBLIC_HEADER DESTINATION include COMPONENT Development
    BUNDLE DESTINATION bin COMPONENT Runtime)

configure_package_config_file(
    "${PROJECT_SOURCE_DIR}/cmake/tangoidlConfig.cmake.in"
    "${PROJECT_BINARY_DIR}/tangoidlConfig.cmake"
    INSTALL_DESTINATION ${ConfigPackageLocation})

export(EXPORT tangoidlTargets
    FILE "${PROJECT_BINARY_DIR}/tangoidlTargets.cmake"
    NAMESPACE ${Namespace})

install(EXPORT tangoidlTargets
    NAMESPACE ${Namespace}
    DESTINATION ${ConfigPackageLocation})

install(FILES "${PROJECT_BINARY_DIR}/tangoidlConfigVersion.cmake"
              "${PROJECT_BINARY_DIR}/tangoidlConfig.cmake"
        DESTINATION ${ConfigPackageLocation})

install(DIRECTORY ${PROJECT_SOURCE_DIR}/include/ DESTINATION include)


configure_file("${PROJECT_SOURCE_DIR}/cmake/tangoidl.pc.cmake"
    "${PROJECT_BINARY_DIR}/tangoidl.pc" @ONLY)

install(FILES "${PROJECT_BINARY_DIR}/tangoidl.pc"
DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

=== lib/java/CMakeLists.txt ===
project(java)

include(GNUInstallDirs)

find_package(Doxygen)
if(Doxygen_FOUND)
  set(DOXYGEN ${DOXYGEN_EXECUTABLE})
else()
  message(STATUS "Doxygen could not be found, pogo will therefore not be able to generate documentation")
endif()

if (NOT WIN32)
    set(SHELL_SCRIPTS astor
                    jive
                    pogo
                    atkpanel
                    logviewer
                    atktuning
                    jdraw
                    synopticappli
                    atkmoni
		    tg_dbdiff
		    tg_devinfo
		    tg_devstate
		    tg_devunexport
		    tg_server
		    tg_dbupdate
		    tg_devping
		    tg_devstatus
		    tg_pool_threads
		    tg_serverinfo
		    tg_dbview
		    tg_devpoll
		    tg_devtest
		    tg_profiler
		    tg_subdevice
                    TangoVers
                    TangoRestServer)

    foreach(input ${SHELL_SCRIPTS})
        configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${input}.in ${input} @ONLY)
        install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/${input}
                DESTINATION ${CMAKE_INSTALL_BINDIR})
    endforeach()
else()
    set(BATCH_SCRIPTS
        start-astor.bat
        start-atkmoni.bat
        start-atkpanel.bat
        start-atktuning.bat
        start-jdraw.bat
        start-jive.bat
        start-logviewer.bat
        start-pogo.bat
        start-synoptic.bat
        tg_dbdiff.bat
        tg_devinfo.bat
        tg_devstate.bat
        tg_devunexport.bat
        tg_server.bat
        tg_dbupdate.bat
        tg_devping.bat
        tg_devstatus.bat
        tg_pool_threads.bat
        tg_serverinfo.bat
        tg_dbview.bat
        tg_devpoll.bat
        tg_devtest.bat
        tg_profiler.bat
        tg_subdevice.bat
        atktuning_attributes.txt)

    foreach(input ${BATCH_SCRIPTS})
        install(PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/${input}
                DESTINATION ${CMAKE_INSTALL_BINDIR})
    endforeach()
endif()

set(CONFIG_XML logback-server.xml
               logback.xml)

foreach(input ${CONFIG_XML})
  install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/${input}
          DESTINATION ${CMAKE_INSTALL_DATADIR}/tango)
endforeach()

# the following list of filenames is replaced with the real names by
# prepare-assets in build.xml, see also https://ant.apache.org/manual/Types/filterset.html
set(JAR_FILES Astor-7.6.0.jar
              ATKCore-9.4.11.jar
              ATKPanel-5.11.jar
              ATKTuning-4.8.jar
              ATKWidget-9.4.11.jar
              DBBench-1.4.jar
              Jive-7.45.jar
              JSSHTerminal-1.18.jar
              JTango-9.6.6.jar
              LogViewer-2.2.1.jar
              Pogo-9.10.4.jar)
if (NOT WIN32)
    list(APPEND JAR_FILES RestServer-1.22.jar)
endif()

foreach(input ${JAR_FILES})
  string(REGEX REPLACE "^([^-]+)-.*(\.jar)$" "\\1\\2" output ${input})
  install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/${input}
          RENAME ${output}
          DESTINATION ${CMAKE_INSTALL_DATADIR}/java)
endforeach()

=== debian/changelog ===
tango (10.1.0+dfsg1-1~exp1) experimental; urgency=medium

  * Team upload
  * New upstream version 10.1.0+dfsg1
  * Remove no longer needed patches:
    - 1090173-sphinx-conf.patch
    - 0001-Fix-timestamp-columns-in-Mariadb-10.11-and-newer.patch
  * Refresh d/patches/0001-assets-CMakeLists.txt-Use-new-package-root-variable-.patch
  * Update documentation generation, also handling the move from rst to myst:
    - Add Build-dependency on python-is-python3 to avoid patching doc/src/Makefile
    - Add myst-parser and sphinx related build-dependencies.
    - Add add-glossary_generator.patch
    - Add patch to remove dependency on hoverxref-extension
    - Add build-dependency on python3-doc
    - Import intersphinx inventory objects from local files
    - Update d/copyright about the new binary inventory objects shipped
    - Add patch to avoid writing sphinx warning and errors to a file
    - Make dh_auto_clean remove files generated by sphinx
  * Add cmake-extras to build-dependencies
  * Install UniversalTest in new binary package tango-universaltest
  * State that libTangoTest.so is not installed in any binary package
  * Bump Standards-Version to 4.7.2, no changes needed

 -- Santiago Ruano Rincón <santiago@freexian.com>  Fri, 05 Sep 2025 14:22:14 -0300

=== debian/control ===
Source: tango
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Picca Frédéric-Emmanuel <picca@debian.org>,
 Roland Mas <lolando@debian.org>,
Section: science
Priority: optional
Build-Depends:
 cmake,
 cmake-extras,
 cppzmq-dev,
 debhelper-compat (= 13),
 default-libmysqlclient-dev,
 libcos4-dev,
 libgrpc++-dev,
 libjpeg-dev,
 libprotobuf-dev,
 omniidl,
 opentelemetry-cpp-dev,
 po-debconf,
 protobuf-compiler-grpc,
 python-is-python3,
 python3-myst-parser,
 python3-sphinx-book-theme,
 python3-sphinx-design,
 python3-sphinx-reredirects,
 python3-sphinx-tags,
 python3-sphinx-togglebutton,
 python3-sphinxcontrib-mermaid,
Build-Depends-Indep:
 doxygen,
 python3-doc,
 python3-ipython,
 python3-sphinx,
 python3-sphinx-copybutton,
 python3-sphinx-rtd-theme,
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/science-team/tango
Vcs-Git: https://salsa.debian.org/science-team/tango.git
Homepage: https://www.tango-controls.org
Rules-Requires-Root: no

Package: libtango10
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 tango-common,
 ${misc:Depends},
 ${shlibs:Depends},
Description: TANGO distributed control system - shared library
 TANGO is an object-oriented distributed control system using CORBA. In
 TANGO all objects are representations of devices, which can be on the
 same computer or distributed over a network. Communication between
 devices uses CORBA and can be synchronous, asynchronous or event driven.
 .
 The object model in TANGO supports methods, attributes and properties.
 TANGO provides an API which hides all the details of network access and
 provides object browsing, discovery, and security features. Permanent
 data is stored in a MySQL/MariaDB database.
 .
 TANGO is being actively developed as a collaborative effort between the
 ESRF (www.esrf.eu), Soleil (synchrotron-soleil.fr), Alba (www.cells.es),
 and Elettra institutes (www.elettra.trieste.it).
 .
 This package contains the files necessary for running TANGO applications.

Package: libtango-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 cppzmq-dev,
 libcos4-dev,
 libjpeg-dev,
 libtango10 (= ${binary:Version}),
 ${misc:Depends},
Conflicts:
 libtango7-dev,
 libtango8-dev,
Description: TANGO distributed control system - development library
 TANGO is an object-oriented distributed control system using CORBA. In
 TANGO all objects are representations of devices, which can be on the
 same computer or distributed over a network. Communication between
 devices uses CORBA and can be synchronous, asynchronous or event driven.
 .
 The object model in TANGO supports methods, attributes and properties.
 TANGO provides an API which hides all the details of network access and
 provides object browsing, discovery, and security features. Permanent
 data is stored in a MySQL/MariaDB database.
 .
 TANGO is being actively developed as a collaborative effort between the
 ESRF (www.esrf.eu), Soleil (synchrotron-soleil.fr), Alba (www.cells.es),
 and Elettra institutes (www.elettra.trieste.it).
 .
 This package contains the tango9 development files.

Package: libtango-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Description: TANGO distributed control system - documentation
 TANGO is an object-oriented distributed control system using CORBA. In
 TANGO all objects are representations of devices, which can be on the
 same computer or distributed over a network. Communication between
 devices uses CORBA and can be synchronous, asynchronous or event driven.
 .
 The object model in TANGO supports methods, attributes and properties.
 TANGO provides an API which hides all the details of network access and
 provides object browsing, discovery, and security features. Permanent
 data is stored in a MySQL/MariaDB database.
 .
 TANGO is being actively developed as a collaborative effort between the
 ESRF (www.esrf.eu), Soleil (synchrotron-soleil.fr), Alba (www.cells.es),
 and Elettra institutes (www.elettra.trieste.it).
 .
 This package contains the documentation for the libtango10 library.

Package: libtango-tools
Architecture: any
Section: net
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: TANGO distributed control system - common executable files
 This package provides shared files for the TANGO distributed control
 system, and sets up the required infrastructure.

Package: tango-common
Architecture: all
Multi-Arch: foreign
Section: net
Depends:
 adduser,
 opentelemetry-cpp,
 ${misc:Depends},
Description: TANGO distributed control system - common files
 This package provides shared files for the TANGO distributed control
 system, and sets up the required infrastructure. It is for now an
 empty package

Package: tango-db
Architecture: any
Section: net
Depends:
 dbconfig-mysql | dbconfig-no-thanks,
 libtango-tools,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 default-mysql-client,
Pre-Depends:
 ${misc:Pre-Depends},
Description: TANGO distributed control system - database server
 TANGO is an object oriented distributed control system. It allows
 communication between TANGO device processes running on the same
 computer or distributed over the network. These processes can
 provide services to the control system all over the network, such as
 hardware control or data processing.
 .
 This package provides a TANGO database server using MySQL/MariaDB.

Package: tango-starter
Architecture: any
Section: net
Depends:
 libtango-tools,
 ${misc:Depends},
 ${shlibs:Depends},
# omninotify is not packaged in debian
# There is an archived RFP: https://bugs.debian.org/134449
#Suggests: omninotify
Pre-Depends:
 ${misc:Pre-Depends},
Description: TANGO distributed control system - starter server
 TANGO is an object oriented distributed control system. It allows
 communication between TANGO device processes running on the same
 computer or distributed over the network. These processes can
 provide services to the control system all over the network, such as
 hardware control or data processing.
 .
 This package provides a TANGO device control server. It can start, stop,
 or report the status of other TANGO components.

Package: tango-accesscontrol
Architecture: any
Section: net
Depends:
 libtango-tools,
 tango-db,
 tango-starter,
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Description: TANGO distributed control system - accesscontrol server
 TANGO is an object oriented distributed control system. It allows
 communication between TANGO device processes running on the same
 computer or distributed over the network. These processes can
 provide services to the control system all over the network, such as
 hardware control or data processing.
 .
 This package provides a TANGO accesscontrol server. It can be used to
 manage the users and IP addresses that are permitted to access TANGO
 devices.

Package: tango-test
Architecture: any
Section: net
Depends:
 tango-starter,
 ${misc:Depends},
 ${shlibs:Depends},
Description: TANGO distributed control system - test device
 TANGO is an object oriented distributed control system. It allows
 communication between TANGO device processes running on the same
 computer or distributed over the network. These processes can
 provide services to the control system all over the network, such as
 hardware control or data processing.
 .
 This package provides a TANGO device which implements all TANGO
 attribute types, and can be used for testing the installation.

Package: tango-universaltest
Architecture: any
Section: net
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: TANGO distributed control system - test device
 TANGO is an object oriented distributed control system. It allows
 communication between TANGO device processes running on the same
 computer or distributed over the network. These processes can
 provide services to the control system all over the network, such as
 hardware control or data processing.
 .
 This package provides a Tango device server able to create dynamic
 attributes of each Tango Type and generating associated expert dynamic
 attributes to be able to change the quality factor or behaviour of the
 other created attributes.

## tango serial-0.2.0

=== docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = python -msphinx
SPHINXPROJ    = tango_serial
SOURCEDIR     = .
BUILDDIR      = _build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)
